SystemOrganization addCategory: #CS528su13!
SystemOrganization addCategory: #'CS528su13-Payroll'!
SystemOrganization addCategory: #'CS528su13-ValueWithHistory'!

TestCase subclass: #EmployeeTestCase
	instanceVariableNames: 'susan day1 normalMonth aLittleOvertime day2 day3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!EmployeeTestCase methodsFor: 'Running' stamp: 'LaurenBridge 6/20/2013 20:34'!
setUp
	day1 := Date 
				newDay: 11
				month: 7
				year: 2001.
	day2 := Date 
				newDay: 15
				month: 7
				year: 2001.
	day3 := Date 
				newDay: 24
				month: 7
				year: 2001.
	susan := Employee new named: 'Susan'.
	normalMonth := #(#(40 0) #(40 0) #(40 0) #(40 0)).
	aLittleOvertime := #(#(40 0) #(50 0) #(40 0) #(40 0))
			! !

!EmployeeTestCase methodsFor: 'as yet unclassified' stamp: 'LaurenBridge 6/23/2013 12:47'!
testAll3WithholdingMakePaycheck

	| paycheck all3 |
	
	all3 := Employee new named: 'Al Three'.
	
	all3 earned at: day1 add: 100.
	paycheck := all3 makePaycheckAt: day1.
	self assert: paycheck amountPaid = 74.3. "really just taxes, others default to 0"
	
	all3 changeRetirementFor: day1 to: 3. 
	all3 changeInsuranceFor: day1 to: 5. 
	paycheck := all3 makePaycheckAt: day1.
	self assert: paycheck amountPaid = 66.3.
	
	all3 withholders removeKey: #taxes.
	paycheck := all3 makePaycheckAt: day1.
	self assert: paycheck amountPaid = 92.! !

!EmployeeTestCase methodsFor: 'Testing' stamp: 'BrianDentino 6/23/2013 00:33'!
testChangeInsurance
	|  nextWeek |
	susan changeInsuranceFor: day1 to: 20.
	self assert: ((susan withholders at: #insurance) amountAt: day1) = 20.
	self assert: ((susan withholders at: #insurance) amountAt: (day1 subtractDays: 1)) = 0.
	nextWeek := day1 addDays: 7.
	susan changeInsuranceFor: nextWeek to: 25.
	self assert: ((susan withholders at: #insurance) amountAt: nextWeek) = 25.
	self assert: ((susan withholders at: #insurance) amountAt: day1) = 20.
	self assert: ((susan withholders at: #insurance) amountAt: (day1 subtractDays: 1)) = 0.
			! !

!EmployeeTestCase methodsFor: 'Testing' stamp: 'LaurenBridge 6/20/2013 22:51'!
testChangeSalary

	susan changeSalaryFor: day1 to: 20.
	self assert: (susan salaryAt: day1) = 20.
	day1 addDays: 7.
	susan changeSalaryFor: day1 to: 25.
	self assert: (susan salaryAt: day1) = 25
			! !

!EmployeeTestCase methodsFor: 'Testing' stamp: 'LaurenBridge 6/20/2013 20:37'!
testChangeSalaryAt

	susan changeSalaryFor: day1 to: 20.
	self assert: (susan salaryAt: day1) = 20.
	self assert: (susan salaryAt: day2) = 20.
	self assert: (susan salaryAt: day3) = 20.
	
	susan changeSalaryFor: day2 to: 35.
	self assert: (susan salaryAt: day1) = 20.
	self assert: (susan salaryAt: day2) = 35.
	self assert: (susan salaryAt: day3) = 35.
	
	susan changeSalaryFor: day3 to: 41.
	self assert: (susan salaryAt: day1) = 20.
	self assert: (susan salaryAt: day2) = 35.
	self assert: (susan salaryAt: day3) = 41.
	
	susan changeSalaryFor: day1 to: 19.
	self assert: (susan salaryAt: day1) = 19.
	self assert: (susan salaryAt: day2) = 35.
	self assert: (susan salaryAt: day3) = 41.! !

!EmployeeTestCase methodsFor: 'Testing' stamp: 'LaurenBridge 6/20/2013 22:53'!
testInitialize

	self assert: susan name = 'Susan'.
	self assert: (susan salaryAt: day1) = 0.
	self assert: (susan earnedAt: day1) = 0.	
	self assert: (susan paidAt: day1) = 0.
	self assert: (susan withholdingAt: day1) = 0.! !

!EmployeeTestCase methodsFor: 'as yet unclassified' stamp: 'LaurenBridge 6/23/2013 12:39'!
testInsuranceWithholdingMakePaycheck

	| paycheck justins |
	
	justins := Employee new named: 'Justin Surance'.
	justins changeInsuranceFor: day1 to: 5. 
	justins withholders removeKey: #taxes.
	justins withholders removeKey: #retirement.
	
	paycheck := justins makePaycheckAt: day1.
	self assert: paycheck amountPaid = 0.

	justins earned at: day1 add: 2.
	paycheck := justins makePaycheckAt: day1.
	self assert: paycheck amountPaid = 2.
	
	justins earned at: day1 add: 18. "20 total"
	paycheck := justins makePaycheckAt: day1.
	self assert: paycheck amountPaid = 15.! !

!EmployeeTestCase methodsFor: 'Testing' stamp: 'BrianDentino 6/23/2013 01:12'!
testMakePaycheckAt
	| paycheck |
	
	paycheck := susan makePaycheckAt: day1.
	self assert: paycheck amountPaid = 0.
	"self assert: paycheck taxes = 0."
	
	susan earned at: day1 add: 20.
	paycheck := susan makePaycheckAt: day1.
	self assert: paycheck amountPaid < 20.
	"self assert: (paycheck taxes + paycheck amountPaid) = 20."

	susan earned at: day2 add: 30.
	paycheck := susan makePaycheckAt: day1.
	self assert: paycheck amountPaid < 20.
	"self assert: (paycheck taxes + paycheck amountPaid) = 20."		
	paycheck := susan makePaycheckAt: day2.
	self assert: paycheck amountPaid < 50.
	"self assert: (paycheck taxes + paycheck amountPaid) = 50."! !

!EmployeeTestCase methodsFor: 'Testing' stamp: 'LaurenBridge 6/20/2013 23:09'!
testPostPaycheck

	susan earned at: day1 add: 20.
	(susan makePaycheckAt: day1) postTo: susan.
	self assert: (susan paidAt: day1) + (susan withholdingAt: day1) = 20.
	self assert: (susan paidAt: day2) + (susan withholdingAt: day2) = 20.
	self assert: (susan paidAt: day3) + (susan withholdingAt: day3) = 20.
	
	susan earned at: day3 add: 10.
	(susan makePaycheckAt: day3) postTo: susan.
	self assert: (susan paidAt: day1) + (susan withholdingAt: day1) = 20.
	self assert: (susan paidAt: day2) + (susan withholdingAt: day2) = 20.
	self assert: (susan paidAt: day3) + (susan withholdingAt: day3) = 30.
	
	susan earned at: day2 add: 5.
	(susan makePaycheckAt: day2) postTo: susan.
	self assert: (susan paidAt: day1) + (susan withholdingAt: day1) = 20.
	self assert: (susan paidAt: day2) + (susan withholdingAt: day2) = 25.
	self assert: (susan paidAt: day3) + (susan withholdingAt: day3) = 35.! !

!EmployeeTestCase methodsFor: 'Testing' stamp: 'LaurenBridge 6/20/2013 23:05'!
testPostTimeCardFor

	susan changeSalaryFor: day1 to: 2. 
	susan postTimeCardFor: day1 hoursWorked: 40 vacation: 0.
	self assert: (susan earnedAt: day1) = 80.
	self assert: (susan earnedAt: day2) = 80.
	self assert: (susan earnedAt: day3) = 80.
		
	susan postTimeCardFor: day3 hoursWorked: 30 vacation: 10.
	self assert: (susan earnedAt: day1) = 80.
	self assert: (susan earnedAt: day2) = 80.
	self assert: (susan earnedAt: day3) = 140.
	
	susan postTimeCardFor: day2 hoursWorked: 50 vacation: 0.
	self assert: (susan earnedAt: day1) = 80.
	self assert: (susan earnedAt: day2) = 190.
	self assert: (susan earnedAt: day3) = 250.
	! !

!EmployeeTestCase methodsFor: 'as yet unclassified' stamp: 'LaurenBridge 6/23/2013 12:40'!
testRetirementWithholdingMakePaycheck

	| paycheck justret  |

	justret := Employee new named: 'Justinre Tirement'.
	justret changeRetirementFor: day1 to: 3. 
	justret withholders removeKey: #taxes.
	justret withholders removeKey: #insurance.

	paycheck := justret makePaycheckAt: day1.
	self assert: paycheck amountPaid = 0.

	justret earned at: day1 add: 2.
	paycheck := justret makePaycheckAt: day1.
	self assert: paycheck amountPaid = 2.
	
	justret earned at: day1 add: 18. "20 total"
	paycheck := justret makePaycheckAt: day1.
	self assert: paycheck amountPaid = 17.! !

!EmployeeTestCase methodsFor: 'Testing' stamp: 'LaurenBridge 6/21/2013 00:49'!
testSalaryHistoryOn

	| stream |
	
	stream := ReadWriteStream on: (String new).

	susan salaryHistoryOn: stream.

	susan changeSalaryFor: day1 to: 20.
	susan changeSalaryFor: day2 to: 35.
	susan changeSalaryFor: day3 to: 41.
	susan changeSalaryFor: day1 to: 19.
	susan salaryHistoryOn: stream.
	stream reset.
	
	self assert: stream contents = '31 December -001: $0 31 December -001: $0 11 July 2001: $20 11 July 2001: $19 15 July 2001: $35 24 July 2001: $41 '.! !

TestCase subclass: #PayrollSystemTestCase
	instanceVariableNames: 'myPayroll day1 susan george normalMonth aLittleOvertime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

PayrollSystemTestCase class
	instanceVariableNames: 'john'!

PayrollSystemTestCase class
	instanceVariableNames: 'john'!

!PayrollSystemTestCase methodsFor: 'private' stamp: ''!
postTimeCards: collection to: anEmployee 
	| timecardDay |
	timecardDay := day1.
	collection do: 
			[:each | 
			anEmployee 
				postTimeCardFor: timecardDay
				hoursWorked: each first
				vacation: each last.
			timecardDay := timecardDay addDays: 7]
			! !

!PayrollSystemTestCase methodsFor: 'Running' stamp: 'BrianDentino 6/4/2013 21:29'!
setUp
	myPayroll := PayrollSystem new name: 'ACME'.
	day1 := Date newDay: 11 month: 7 year: 2001. 
	susan := Employee new named: 'Susan'.
	susan changeSalaryFor: day1 to: 20.
	george := Employee new named: 'George'.
	george changeSalaryFor: day1 to: 12.
	
	normalMonth := #(#(40 0) #(40 0) #(40 0) #(40 0)).
	aLittleOvertime := #(#(40 0) #(50 0) #(40 0) #(40 0))
			! !

!PayrollSystemTestCase methodsFor: 'Testing' stamp: ''!
testAddEmployee
	myPayroll addEmployee: susan.
	self assert: (myPayroll employeeNames includes: 'Susan').
	myPayroll addEmployee: george.
	self assert: (myPayroll employeeNamed: 'Susan') = susan
			! !

!PayrollSystemTestCase methodsFor: 'Testing' stamp: 'LaurenBridge 6/20/2013 23:14'!
testEarnings
	myPayroll
		addEmployee: susan;
		addEmployee: george.
	self postTimeCards: normalMonth to: susan.
	self postTimeCards: aLittleOvertime to: george.
	self assert: (susan earnedAt: (day1 addDays: 28)) = 3200.
	self assert: (george earnedAt: (day1 addDays: 28)) = 2100
			! !

!PayrollSystemTestCase methodsFor: 'as yet unclassified' stamp: 'LaurenBridge 6/20/2013 23:49'!
testLateTimecard

	| fred payroll day8 day17 day20 |
	
	fred := Employee new named: 'Fred'.
	day8 := day1 addDays: 7.
	day17 := day8 addDays: 7.
	day20 := day17 addDays: 3.
		
	payroll := PayrollSystem new name: 'testPayroll'.	
	payroll addEmployee: fred.
	
	"starting salary of 2"
	fred changeSalaryFor: day1 to: 2. 
	
	"normal week"
	fred postTimeCardFor: day8 hoursWorked: 40 vacation: 0.
	payroll makePaychecksAt: day8.
	payroll postPaychecks.
	self assert: (fred earnedAt: day8 ) = 80.
	self assert: (fred paidAt: day8) = 
		((fred earnedAt: day8) - (fred withholdingAt: day8)).
	
	"salary increase"
	fred changeSalaryFor: day20 to: 2.5.	
	
	"late timecard... should still be old salary"
	fred postTimeCardFor: day17 hoursWorked: 40 vacation: 0.
	payroll makePaychecksAt: day17.
	payroll postPaychecks.
	self assert: (fred earnedAt: day17 ) = 160.
	self assert: (fred paidAt: day17 ) = 
		((fred earnedAt: day17) - (fred withholdingAt: day17)).! !

!PayrollSystemTestCase methodsFor: 'as yet unclassified' stamp: 'LaurenBridge 6/23/2013 13:03'!
testLateTimecardWInsuranceChange

	| fred payroll day8 day17 day20 |
	
	fred := Employee new named: 'Fred'.
	day8 := day1 addDays: 7.
	day17 := day8 addDays: 7.
	day20 := day17 addDays: 3.
		
	payroll := PayrollSystem new name: 'testPayroll'.	
	payroll addEmployee: fred.
	
	"starting salary of 2"
	fred changeSalaryFor: day1 to: 2. 
	fred withholders removeKey: #taxes.
	fred changeInsuranceFor: day1 to: 15.
	
	"normal week"
	fred postTimeCardFor: day8 hoursWorked: 40 vacation: 0.
	payroll makePaychecksAt: day8.
	payroll postPaychecks.
	self assert: (fred earnedAt: day8) = 80.
	self assert: (fred paidAt: day8) = 65.
	
	"insurance increase"
	fred changeInsuranceFor: day20 to: 18.	
	
	"late timecard... should still be old insruance"
	fred postTimeCardFor: day17 hoursWorked: 40 vacation: 0.
	payroll makePaychecksAt: day17.
	payroll postPaychecks.
	self assert: (fred earnedAt: day17) = 160.
	self assert: (fred paidAt: day17) = 130.
	self assert: (fred paidAt: day17 ) = 
		((fred earnedAt: day17) - (fred withholdingAt: day17)).	! !

!PayrollSystemTestCase methodsFor: 'as yet unclassified' stamp: 'BrianDentino 6/23/2013 01:24'!
testPaycheckString
	| expectedString john currentDate payroll |
	
	expectedString := '

                                        15 May 1999
John Doe                                



this month   amountPaid: $1038.8 #insurance: $100 #taxes: $411.2 #retirement: $50
year to date   amountPaid: $1038.8 #insurance: $100 #taxes: $411.2 #retirement: $50

'.
	john := Employee new named: 'John Doe'.
	currentDate := Date newDay: 1 month: 5 year: 1999.
	john changeSalaryFor: currentDate to: 20.
	john changeInsuranceFor: currentDate to: 100.
	john changeRetirementFor: currentDate to: 50.
	
	payroll := PayrollSystem new name: 'testPayroll'.	
	payroll addEmployee: john.
		
	currentDate := currentDate addDays: 4.
	john postTimeCardFor: currentDate hoursWorked: 40 vacation: 0.
	currentDate := currentDate addDays: 7.
	john postTimeCardFor: currentDate hoursWorked: 40 vacation: 0.
	currentDate := currentDate addDays: 3.
	payroll makePaychecksAt: currentDate.
	
	self assert: (payroll paycheckString = expectedString).! !

!PayrollSystemTestCase methodsFor: 'Testing' stamp: 'BrianDentino 6/23/2013 01:14'!
testTakeHomePay
	"test that employees are paid after paychecks are posted and that pay = earned - withholding"

	| john currentDate payroll |
	
	john := Employee new named: 'John Doe'.
	currentDate := Date newDay: 1 month: 5 year: 1999.
	john changeSalaryFor: currentDate to: 20.
	john changeInsuranceFor: currentDate to: 100.
	john changeRetirementFor: currentDate to: 50.
	
	payroll := PayrollSystem new name: 'testPayroll'.	
	payroll addEmployee: john.
		
	currentDate := currentDate addDays: 4.
	john postTimeCardFor: currentDate hoursWorked: 40 vacation: 0.
	currentDate := currentDate addDays: 7.
	john postTimeCardFor: currentDate hoursWorked: 40 vacation: 0.
	currentDate := currentDate addDays: 3.
	payroll makePaychecksAt: currentDate.

	payroll paycheckString.
	payroll postPaychecks.

	self assert: ((john paidAt: currentDate) = ((john earnedAt: currentDate) - (john withholdingAt: currentDate))).! !

!PayrollSystemTestCase methodsFor: 'as yet unclassified' stamp: 'LaurenBridge 6/23/2013 12:57'!
testValidPaycheckNoTaxes

	| fred payroll day8 |
	
	fred := Employee new named: 'Fred'.
	day8 := day1 addDays: 7.
		
	payroll := PayrollSystem new name: 'testPayroll'.	
	payroll addEmployee: fred.
	
	"starting salary of 2"
	fred changeSalaryFor: day1 to: 2. 
	fred withholders removeKey: #taxes.
	fred changeRetirementFor: day1 to: 3.
	fred changeInsuranceFor: day1 to: 15.
	
	"normal week"
	fred postTimeCardFor: day8 hoursWorked: 40 vacation: 0.
	payroll makePaychecksAt: day8.
	payroll postPaychecks.
	self assert: (fred earnedAt: day8 ) = 80.
	self assert: (fred withholdingAt: day8) = 18.
	self assert: (fred paidAt: day8) = 62.! !

!PayrollSystemTestCase methodsFor: 'as yet unclassified' stamp: 'LaurenBridge 6/23/2013 13:01'!
testValidTimecardWInsuranceChange

	| fred payroll day8 day17 |
	
	fred := Employee new named: 'Fred'.
	day8 := day1 addDays: 7.
	day17 := day8 addDays: 7.
		
	payroll := PayrollSystem new name: 'testPayroll'.	
	payroll addEmployee: fred.
	
	"starting salary of 2"
	fred changeSalaryFor: day1 to: 2. 
	fred withholders removeKey: #taxes.
	fred changeInsuranceFor: day1 to: 15.
	
	"normal week"
	fred postTimeCardFor: day8 hoursWorked: 40 vacation: 0.
	payroll makePaychecksAt: day8.
	payroll postPaychecks.
	self assert: (fred earnedAt: day8) = 80.
	self assert: (fred paidAt: day8) = 65.
	
	"insurance increase"
	fred changeInsuranceFor: (day8 addDays: 1) to: 18.	
	
	"new salary"
	fred postTimeCardFor: day17 hoursWorked: 40 vacation: 0.
	payroll makePaychecksAt: day17.
	payroll postPaychecks.
	self assert: (fred earnedAt: day17) = 160.
	self assert: (fred paidAt: day17) = 127.
	self assert: (fred paidAt: day17 ) = 
		((fred earnedAt: day17) - (fred withholdingAt: day17)).! !

!PayrollSystemTestCase methodsFor: 'as yet unclassified' stamp: 'LaurenBridge 6/20/2013 23:51'!
testValidTimecardWSalaryIncrease

	| fred payroll day8 day17 |
	
	fred := Employee new named: 'Fred'.
	day8 := day1 addDays: 7.
	day17 := day8 addDays: 7.
		
	payroll := PayrollSystem new name: 'testPayroll'.	
	payroll addEmployee: fred.
	
	"starting salary of 2"
	fred changeSalaryFor: day1 to: 2. 
	
	"normal week"
	fred postTimeCardFor: day8 hoursWorked: 40 vacation: 0.
	payroll makePaychecksAt: day8.
	payroll postPaychecks.
	self assert: (fred earnedAt: day8 ) = 80.
	self assert: (fred paidAt: day8) = 
		((fred earnedAt: day8) - (fred withholdingAt: day8)).
	
	"salary increase"
	fred changeSalaryFor: (day8 addDays: 1) to: 2.5.	
	
	"new salary"
	fred postTimeCardFor: day17 hoursWorked: 40 vacation: 0.
	payroll makePaychecksAt: day17.
	payroll postPaychecks.
	self assert: (fred earnedAt: day17 ) = 180.
	self assert: (fred paidAt: day17 ) = 
		((fred earnedAt: day17) - (fred withholdingAt: day17)).! !

TestCase subclass: #SortedSequenceTestCase
	instanceVariableNames: 'sequence'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!SortedSequenceTestCase methodsFor: 'Running' stamp: ''!
setUp
	sequence := SortedSequence new.
	sequence add: 1; add: 80; add: 500; add: 501
			! !

!SortedSequenceTestCase methodsFor: 'Testing' stamp: ''!
testIndex
	"(SortedSequenceTestCase selector: #testIndex) run"

	self assert: (sequence indexOfStartOfIntervalContaining: 1) = 1.
	self assert: (sequence indexOfStartOfIntervalContaining: 79) = 1.
	self assert: (sequence indexOfStartOfIntervalContaining: 80) = 2.
	self assert: (sequence indexOfStartOfIntervalContaining: 501)	= 4
			! !

TestCase subclass: #ValueWithHistoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-ValueWithHistory'!

!ValueWithHistoryTest methodsFor: 'testing' stamp: 'm3r 6/27/2008 02:15'!
test
	| history day3 day2 day1 day4 |
	day3 := '12/12/2007' asDate.
	day2 := day3 subtractDays: 3.
	day1 := day2 subtractDays: 3.
	day4 :=  day3 addDays: 4.
	(history := ValueWithHistory new) starting: day3 become: 3.
	history starting: day1 become: 1.
	self should: [(history at: day2) = 1].
	history at: day2 add: 1.
	self should: [(history at: day3) = 4].
	history at: day4 add: 2.
	self should: [(history at: day4) = 6].
! !

SortedCollection variableSubclass: #SortedSequence
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!SortedSequence commentStamp: '<historical>' prior: 0!
I add one method to SortedCollection.  It would be just as easy to add the method
directly to the class instead of making a subclass, but this makes it easier to see
the new method.

The method is indexOfStartOfIntervalContaining: anElement
It returns the index of anElement or, if it is not present, the index of the
largest element smaller than it.  It is useful when you want to have a
table that is sorted by keys and you want to look up in the table to
find the nearest match to a key.!

!SortedSequence methodsFor: 'accessing' stamp: ''!
indexOfStartOfIntervalContaining: anElement 
	"Return the index of anElement or, if it is not present, of the index of the
	largest element smaller than it."

	self isEmpty ifTrue: [^0].
	^(self indexForInserting: anElement) - firstIndex
			! !

Object subclass: #Employee
	instanceVariableNames: 'name transactions salary earned paid accruedVacation withholding withholders'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!Employee commentStamp: '<historical>' prior: 0!
I represent an employee in a payroll system.  Thus, I keep track of the number of hours worked,
the wages paid, the vacation accrued, the taxes withheld, and so on.  My values change only
when transactions are posted to me.  Transactions are subclasses of EmployeeTransaction.

Variables
	name 				<String>
	transactions 			<Collection of Transactions, sorted by date>
	salary 				<ValueWithHistory>
	earned  				<ValueWithHistory>
	paid  				<ValueWithHistory>
	withholding  			<ValueWithHistory>
	accruedVacation  	<ValueWithHistory>
	taxRule 				<TaxRule>!

!Employee methodsFor: 'actions' stamp: 'BrianDentino 6/22/2013 11:15'!
changeInsuranceFor: aDate to: dollars 
	self postTransaction: (InsuranceChange
			date: aDate
			employee: self
			amountPerPaycheck: dollars)
			! !

!Employee methodsFor: 'actions' stamp: 'BrianDentino 6/23/2013 01:11'!
changeRetirementFor: aDate to: dollars 
	self postTransaction: (RetirementChange
			date: aDate
			employee: self
			amountPerPaycheck: dollars)
			! !

!Employee methodsFor: 'actions' stamp: 'BrianDentino 6/4/2013 20:16'!
changeSalaryFor: aDate to: dollarPerHour 
	self postTransaction: (SalaryChange
			date: aDate
			employee: self
			salary: dollarPerHour)
			! !

!Employee methodsFor: 'accessing' stamp: 'LaurenBridge 6/20/2013 22:19'!
earned
	^ earned! !

!Employee methodsFor: 'accessing' stamp: 'LaurenBridge 6/20/2013 21:36'!
earnedAt: aDate
	^ earned at: aDate
			! !

!Employee methodsFor: 'posting' stamp: 'BrianDentino 6/22/2013 22:32'!
incrementWithholdingFor: withholder by: anAmount at: aDate
	(withholding at: withholder) at: aDate add: anAmount
			! !

!Employee methodsFor: 'actions' stamp: 'BrianDentino 6/22/2013 22:27'!
makePaycheckAt: aDate 
	"Create a paycheck for the amount owed to the employee. It hasn't 
	been posted."
	
	| amountPaid paycheck |
	amountPaid := (self earnedAt: aDate) - (self paidAt: aDate) - (self withholdingAt: aDate).
	paycheck := Paycheck date: aDate 
		employee: self 
		paid: amountPaid
		withholders: withholders.

	^paycheck
! !

!Employee methodsFor: 'accessing' stamp: ''!
name
	^name
			! !

!Employee methodsFor: 'initialize-release' stamp: 'BrianDentino 6/23/2013 01:17'!
named: aString
	name := aString.
	transactions := OrderedCollection new.
	salary := ValueWithHistory zero.
	earned := ValueWithHistory zero.
	paid := ValueWithHistory zero.
	accruedVacation := ValueWithHistory zero.
	
	withholders := Dictionary new.
	withholders at: #insurance put: InsuranceWithholder new.
	withholders at: #taxes put: TaxWithholder new.
	withholders at: #retirement put: RetirementWithholder new.
	
	withholding := Dictionary new.
	withholding at: #insurance put: ValueWithHistory zero.
	withholding at: #taxes put: ValueWithHistory zero.
	withholding at: #retirement put: ValueWithHistory zero.! !

!Employee methodsFor: 'accessing' stamp: 'LaurenBridge 6/20/2013 22:19'!
paid
	^ paid
			! !

!Employee methodsFor: 'accessing' stamp: 'LaurenBridge 6/20/2013 21:36'!
paidAt: aDate
	^ paid at: aDate
			! !

!Employee methodsFor: 'actions' stamp: ''!
postTimeCardFor: aDate hoursWorked: hoursW vacation: hoursV 
	self postTransaction: (Timecard new
			date: aDate
			employee: self
			worked: hoursW
			vacation: hoursV)
			! !

!Employee methodsFor: 'posting' stamp: ''!
postTransaction: aTransaction
	"Public interface to record and process (i.e. post) a transaction."
	aTransaction postTo: self.
	transactions add: aTransaction
			! !

!Employee methodsFor: 'accessing' stamp: ''!
salary
	^salary
			! !

!Employee methodsFor: 'accessing' stamp: 'LaurenBridge 6/20/2013 21:35'!
salaryAt: aDate
	^ salary at: aDate
			! !

!Employee methodsFor: 'as yet unclassified' stamp: 'LaurenBridge 6/21/2013 00:26'!
salaryHistoryOn: aStream

	"prints a report to aStream that gives the dates of all salary changes and what the 	new salary was. The report should follow this style:
	'11 July 2001: $20 18 July 2001: $25'"
	
	salary printOn: aStream.! !

!Employee methodsFor: 'accessing' stamp: 'BrianDentino 6/22/2013 23:58'!
withholders
	^withholders! !

!Employee methodsFor: 'accessing' stamp: 'BrianDentino 6/22/2013 22:41'!
withholdingAt: aDate
	^ withholding inject: 0 into: [ :sum :each | sum + (each at: aDate) ]! !

!Employee methodsFor: 'accessing' stamp: 'BrianDentino 6/23/2013 00:31'!
withholdingFor: withholder at: aDate
	^(withholding at: withholder) at: aDate! !

Object subclass: #EmployeeTransaction
	instanceVariableNames: 'date employee'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!EmployeeTransaction commentStamp: '<historical>' prior: 0!
I'm an abstract class of transactions that can be posted to an Employee.

My most important method is postTo:, which is implemented by subclasses
to send a message to the Employee to post the transaction.  The Employee
has all the information, so it has to be the one to implement posting, but the
postTo: method implements a standard interface so that clients of the
payroll system can always post a transaction by sending the postTransaction:
message to an Employee.

Variables
	date		<Date>   Date at which transaction occured.
	employee	<Employee>

!

!EmployeeTransaction methodsFor: 'accessing' stamp: ''!
date
	^date
			! !

!EmployeeTransaction methodsFor: 'posting' stamp: ''!
post
	employee postTransaction: self
			! !

!EmployeeTransaction methodsFor: 'posting' stamp: ''!
postTo: anEmployee
	"double dispatching"
	self subclassResponsibility
			! !

EmployeeTransaction subclass: #InsuranceChange
	instanceVariableNames: 'newInsurance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!InsuranceChange commentStamp: '<historical>' prior: 0!
Transaction representing a change in Insurance payment.!

!InsuranceChange class methodsFor: 'as yet unclassified' stamp: 'BrianDentino 6/22/2013 11:14'!
date: aDate employee: anEmployee amountPerPaycheck: insurance
	"class message for instance initialization"
	^((InsuranceChange new) date: aDate employee: anEmployee amountPerPaycheck: insurance)! !

!InsuranceChange methodsFor: 'as yet unclassified' stamp: 'BrianDentino 6/22/2013 10:16'!
date: aDate employee: anEmployee amountPerPaycheck: amountPerPaycheck
	date := aDate.
	employee := anEmployee.
	newInsurance := amountPerPaycheck! !

!InsuranceChange methodsFor: 'as yet unclassified' stamp: 'BrianDentino 6/22/2013 10:17'!
newInsurance
	^newInsurance! !

!InsuranceChange methodsFor: 'as yet unclassified' stamp: 'BrianDentino 6/22/2013 23:58'!
postTo: anEmployee
	((anEmployee withholders) at: #insurance) setAmount: newInsurance at: date! !

EmployeeTransaction subclass: #Paycheck
	instanceVariableNames: 'amountPaid totalPaid withholders totalWithholding'
	classVariableNames: 'AmountFormat DateFormat'
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!Paycheck commentStamp: '<historical>' prior: 0!
Transaction representing a payment to an employee.!

!Paycheck class methodsFor: 'instance creation' stamp: 'BrianDentino 6/22/2013 23:48'!
date: aDate employee: anEmployee paid: pay withholders: employeeWithholders
	^(Paycheck new) date: aDate employee: anEmployee paid: pay withholders: employeeWithholders! !

!Paycheck class methodsFor: 'class initialization' stamp: 'BrianDentino 6/23/2013 00:47'!
initialize
	"Paycheck initialize"

"	AmountFormat := NumberPrintPolicy newFor: #usCurrency.
	DateFormat := TimestampPrintPolicy newFor: #us"
			! !

!Paycheck methodsFor: 'accessing' stamp: ''!
amountPaid
	^amountPaid
			! !

!Paycheck methodsFor: 'initialize-release' stamp: 'BrianDentino 6/23/2013 01:21'!
date: aDate employee: anEmployee paid: pay withholders: employeeWithholders
	date := aDate.
	employee := anEmployee.
	amountPaid := pay.
	withholders := Dictionary new.
	totalWithholding := Dictionary new.
	
	employeeWithholders keysAndValuesDo: 
		[ :key :withholder | withholders at: key put: (withholder withholdingOn: self for: anEmployee at: aDate) ].
	
	withholders valuesDo: 
		[ :value | amountPaid := amountPaid - value ].
	
	totalPaid := amountPaid + (anEmployee paidAt: aDate).
	
	withholders keysAndValuesDo: 
		[ :key :value | totalWithholding at: key put: (value + (anEmployee withholdingFor: key at: aDate)) ]
	! !

!Paycheck methodsFor: 'posting' stamp: 'BrianDentino 6/22/2013 23:54'!
postTo: anEmployee
	anEmployee paid at: date add: amountPaid.
	(withholders keys) do: 
		[ :withholder | anEmployee incrementWithholdingFor: withholder by: (withholders at: withholder) at: date ].! !

!Paycheck methodsFor: 'printing' stamp: 'BrianDentino 6/23/2013 01:21'!
printOnCheckStream: aStream
	"This method is supposed to print information on a check that is on the printer, and
	aStream is the printer.  Unfortunately, the whole method is bogus, because we don't
	know what the printer or the check are like.  I'm assuming that the check has two-parts.
	One is the actual check, and we need to print the employee's name and the amount.
	The second is the check stub, which will say how much is being paid and how much
 	is being withheld. I'm also assuming that the check is preprinted with the name of the
	company, and everything else that is usual for a check."

	aStream cr; cr.
	aStream next: 40 put: (Character space).
	date printOn: aStream.

	aStream cr.
	aStream nextPutAll: ((String new: 40 withAll: Character space) copyReplaceFrom: 1 to: employee name size with: employee name).

	aStream cr; cr; cr; cr.
	aStream nextPutAll: 'this month  '.
	aStream nextPutAll: ' amountPaid: $'.
	amountPaid printOn: aStream.

	withholders keysAndValuesDo: 
		[ :key :value | aStream nextPutAll: ' '. key printOn: aStream. aStream nextPutAll: ': $'. value printOn: aStream. ].

	aStream cr.
	aStream nextPutAll: 'year to date  '.
	aStream nextPutAll: ' amountPaid: $'.
	totalPaid printOn: aStream.
	
	totalWithholding keysAndValuesDo: 
		[ :key :value | aStream nextPutAll: ' '. key printOn: aStream. aStream nextPutAll: ': $'. value printOn: aStream. ].

	aStream cr; cr.
			! !

!Paycheck methodsFor: 'as yet unclassified' stamp: 'BrianDentino 6/23/2013 01:02'!
totalWithholding: anAmount for: withholder
	totalWithholding at: withholder put: anAmount! !

!Paycheck methodsFor: 'as yet unclassified' stamp: 'BrianDentino 6/23/2013 01:01'!
withhold: anAmount for: withholder
	withholders at: withholder put: anAmount! !

EmployeeTransaction subclass: #RetirementChange
	instanceVariableNames: 'newRetirement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!RetirementChange commentStamp: '<historical>' prior: 0!
A RetirementChange is xxxxxxxxx.

Instance Variables
	newRetirement:		<Object>

newRetirement
	- xxxxx
!

!RetirementChange class methodsFor: 'as yet unclassified' stamp: 'BrianDentino 6/23/2013 01:13'!
date: aDate employee: anEmployee amountPerPaycheck: insurance
	"class message for instance initialization"
	^((RetirementChange new) date: aDate employee: anEmployee amountPerPaycheck: insurance)! !

!RetirementChange methodsFor: 'as yet unclassified' stamp: 'BrianDentino 6/23/2013 01:10'!
date: aDate employee: anEmployee amountPerPaycheck: amountPerPaycheck
	date := aDate.
	employee := anEmployee.
	newRetirement := amountPerPaycheck! !

!RetirementChange methodsFor: 'as yet unclassified' stamp: 'BrianDentino 6/23/2013 01:11'!
newRetirement
	^newRetirement! !

!RetirementChange methodsFor: 'as yet unclassified' stamp: 'BrianDentino 6/23/2013 01:22'!
postTo: anEmployee
	((anEmployee withholders) at: #retirement) setAmount: newRetirement at: date! !

EmployeeTransaction subclass: #SalaryChange
	instanceVariableNames: 'newSalary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!SalaryChange commentStamp: '<historical>' prior: 0!
Transaction representing a change in salary, usually a raise.!

!SalaryChange class methodsFor: 'instance creation' stamp: 'BrianDentino 6/4/2013 20:15'!
date: aDate employee: anEmployee salary: aSalary
	"class message for instance initialization"
	^((SalaryChange new) date: aDate employee: anEmployee salary: aSalary)! !

!SalaryChange methodsFor: 'initialize-release' stamp: ''!
date: aDate employee: anEmployee salary: dollarPerHour
	date := aDate.
	employee := anEmployee.
	newSalary := dollarPerHour
			! !

!SalaryChange methodsFor: 'accessing' stamp: ''!
newSalary
	^newSalary
			! !

!SalaryChange methodsFor: 'posting' stamp: 'LaurenBridge 6/20/2013 21:41'!
postTo: anEmployee
	anEmployee salary starting: date become: newSalary
			! !

EmployeeTransaction subclass: #Timecard
	instanceVariableNames: 'hoursWorked hoursVacation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!Timecard commentStamp: '<historical>' prior: 0!
Transaction representing the work that the employee has done.!

!Timecard class methodsFor: 'instance creation' stamp: 'BrianDentino 6/4/2013 21:08'!
date: aDate employee: anEmployee worked: hoursW vacation: hoursV
	^Timecard new date: aDate employee: anEmployee worked: hoursW vacation: hoursV! !

!Timecard methodsFor: 'initialize-release' stamp: ''!
date: aDate employee: anEmployee worked: hoursW vacation: hoursV
	date := aDate.
	employee := anEmployee.
	hoursWorked := hoursW.
	hoursVacation := hoursV
			! !

!Timecard methodsFor: 'accessing' stamp: ''!
hoursVacation
	^hoursVacation
			! !

!Timecard methodsFor: 'accessing' stamp: ''!
hoursWorked
	^hoursWorked
			! !

!Timecard methodsFor: 'posting' stamp: 'LaurenBridge 6/20/2013 21:32'!
postTo: anEmployee 
	| money overtime nonovertime |
	overtime := hoursWorked - 40 max: 0.
	nonovertime := hoursWorked min: 40.
	money := overtime * 1.5 + nonovertime * (anEmployee salaryAt: date).
	anEmployee earned at: date add: money
			! !

Object subclass: #PayrollSystem
	instanceVariableNames: 'employees paychecks companyName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!PayrollSystem commentStamp: '<historical>' prior: 0!
I am the top-level of the payroll system.  I keep track of the employees
and can "run the payroll", i.e. write paychecks for the employees.  To
run the payroll, send the messages
	makePaychecksAt: paydate	- to create the paycheck transactions
	printPaychecksOn: aStream	- to print them out 
	postPaychecks				- to record them in employees

Note that the employees are not marked with having been paid until
the paychecks are posted, so just creating the transactions or even
printing them is not enough.

Variables
	employees   <Dictionary from String to Employee>
	paychecks 	<Collection of Paycheck>	holds paychecks that have been created until they have been posted!

!PayrollSystem class methodsFor: 'instance creation' stamp: ''!
new
	^super new initialize
			! !

!PayrollSystem methodsFor: 'accessing' stamp: ''!
addEmployee: anEmployee
	employees at: anEmployee name put: anEmployee
			! !

!PayrollSystem methodsFor: 'accessing' stamp: ''!
employeeNamed: aName
	^employees at: aName
			! !

!PayrollSystem methodsFor: 'accessing' stamp: ''!
employeeNames
	^employees keys asOrderedCollection
			! !

!PayrollSystem methodsFor: 'initialize-release' stamp: ''!
initialize
	employees := Dictionary new.
			! !

!PayrollSystem methodsFor: 'actions' stamp: ''!
makePaychecksAt: aDate 
	paychecks := employees collect: [:eachEmployee | eachEmployee makePaycheckAt: aDate]
			! !

!PayrollSystem methodsFor: 'accessing' stamp: ''!
name
	^companyName
			! !

!PayrollSystem methodsFor: 'accessing' stamp: ''!
name: aString
	companyName := aString
			! !

!PayrollSystem methodsFor: 'actions' stamp: ''!
paycheckString
	| aStream |
	aStream := WriteStream on: (String new: 20).
	self printPaychecksOn: aStream.
	^aStream contents
			! !

!PayrollSystem methodsFor: 'actions' stamp: ''!
postPaychecks
	paychecks do: [:each | each post].
	paychecks := #()
			! !

!PayrollSystem methodsFor: 'actions' stamp: ''!
printPaychecksOn: aStream 
	paychecks do: [:each | each printOnCheckStream: aStream]
			! !

Object subclass: #TaxRule
	instanceVariableNames: 'breakPoints rates'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!TaxRule commentStamp: '<historical>' prior: 0!
I represent a tax table.  Given a yearly taxable income, I can give the tax rate for it.
I store the tax table as a sequence of amounts, and the tax rate for that amount.
For example, in 1994 the tax rate for a single person (schedule X) was
           $0		15%
  $22750	28%
  $55100	31%
$115000	36%
$250000	39.6%

breakpoints  	<SortedCollection of: integer>
rates	 	<OrderedCollection of: integer>!

!TaxRule class methodsFor: 'instance creation' stamp: ''!
new
	^super new initialize
			! !

!TaxRule methodsFor: 'accessing' stamp: ''!
breakPoint: aNumber rate: anotherNumber 
	"Add an entry to the tax table"

	| index |
	index := breakPoints indexOfStartOfIntervalContaining: aNumber.
	breakPoints add: aNumber.
	rates add: anotherNumber beforeIndex: index + 1
			! !

!TaxRule methodsFor: 'initialize-release' stamp: ''!
initialize
	breakPoints := SortedSequence new.
	rates := OrderedCollection new.
			! !

!TaxRule methodsFor: 'accessing' stamp: ''!
rateFor: aNumber 
	"Return the tax rate for someone whose taxable income is 
	aNumber dollars."

	^rates at: (breakPoints indexOfStartOfIntervalContaining: aNumber)
			! !

Object subclass: #ValueWithHistory
	instanceVariableNames: 'date value'
	classVariableNames: 'EarliestDate'
	poolDictionaries: ''
	category: 'CS528su13-ValueWithHistory'!

!ValueWithHistory commentStamp: 'm3r 6/27/2008 01:58' prior: 0!
I represent a (probably numerical) value that changes over time.  I can answer my value at any point in
time (usually a date).  I can update my value at any point in time, and also add a number to my
value from any point in time on into the future.  My value does not change continuously, but changes
at discrete points in time.

Instance Variables:
	date	<SortedCollection of: Date>
	value	<OrderedCollection of: Number>
	The i'th element of value matches the i'th element of date.  The date collection indicates when the value takes on the next element of the value collection.
!

!ValueWithHistory class methodsFor: 'class initialization' stamp: 'm3r 6/27/2008 02:05'!
initialize
	"self initialize"
	EarliestDate := Date newDay: 0 year: 0.
! !

!ValueWithHistory class methodsFor: 'instance creation' stamp: 'm3r 6/27/2008 02:06'!
new
	^ super new initialize
! !

!ValueWithHistory class methodsFor: 'instance creation' stamp: 'm3r 6/27/2008 02:06'!
zero
	^ self new starting: EarliestDate become: 0
! !

!ValueWithHistory methodsFor: 'accessing' stamp: 'm3r 6/27/2008 01:58'!
at: aDate 
	"Return value at aDate"
	| index |
	index := date indexOfStartOfIntervalContaining: aDate.
	index = 0 ifTrue: [self error: 'date is too early'].
	^value at: index
! !

!ValueWithHistory methodsFor: 'accessing' stamp: 'm3r 6/27/2008 01:59'!
at: aDate add: amount 
"Add amount to the value starting at aDate."
	| start |
	start := self indexForAccessing: aDate.
	start to: value size do:
		[:each | value at: each put: (value at: each) + amount].
! !

!ValueWithHistory methodsFor: 'accessing' stamp: 'm3r 6/27/2008 02:00'!
indexForAccessing: aDate 
	"Create index of slot for aDate, creating it if necessary."
	| index |
	(index := date indexOfStartOfIntervalContaining: aDate) = 0 ifTrue: 
		[date add: aDate.
		value addFirst: 0.
		^ 1].
	(date at: index) = aDate ifTrue: [^index].
	date add: aDate.
	value add: (value at: index) beforeIndex: index + 1.
	^ index + 1
! !

!ValueWithHistory methodsFor: 'initialize-release' stamp: 'ChaseGeigle 6/15/2013 23:01'!
initialize
	date := SortedSequence new.
	value := OrderedCollection new.
! !

!ValueWithHistory methodsFor: 'printing' stamp: 'LaurenBridge 6/21/2013 00:45'!
printOn: aStream 

	date with: value do: 
		[: nextDate : nextValue | 
		aStream 
			print: nextDate;
			nextPutAll: ': $';
			print: nextValue;
			space].
	
"	date with: value do: 
		[: nextDate : nextValue | 
		aStream 
			nextPut: $(;
			print: nextDate;
			nextPutAll: ' -> ';
			print: nextValue;
			nextPut: $);
			cr]."
! !

!ValueWithHistory methodsFor: 'accessing' stamp: 'm3r 6/27/2008 02:00'!
starting: aDate become: anAmount 
	| index |
	date add: aDate.
	index := date indexOfStartOfIntervalContaining: aDate.
	value add: anAmount beforeIndex: index.
! !

Object subclass: #Withholder
	instanceVariableNames: 'totalWithholding'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!Withholder commentStamp: '<historical>' prior: 0!
A Withholder is xxxxxxxxx.

Instance Variables
!

Withholder subclass: #InsuranceWithholder
	instanceVariableNames: 'amountWithheld'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!InsuranceWithholder commentStamp: '<historical>' prior: 0!
An InsuranceWithholder is xxxxxxxxx.

Instance Variables
	amountWithheld:		<Object>

amountWithheld
	- xxxxx
!

!InsuranceWithholder methodsFor: 'as yet unclassified' stamp: 'BrianDentino 6/22/2013 18:50'!
amountAt: aDate 
	^amountWithheld at: aDate! !

!InsuranceWithholder methodsFor: 'as yet unclassified' stamp: 'BrianDentino 6/23/2013 00:15'!
initialize
	super initialize.
	amountWithheld := ValueWithHistory zero.! !

!InsuranceWithholder methodsFor: 'as yet unclassified' stamp: 'BrianDentino 6/22/2013 18:27'!
setAmount: anAmount at: aDate
	amountWithheld starting: aDate become: anAmount! !

!InsuranceWithholder methodsFor: 'as yet unclassified' stamp: 'LaurenBridge 6/23/2013 12:36'!
withholdingOn: aCheck for: anEmployee at: aDate	
	(amountWithheld at: aDate) > (aCheck amountPaid) ifTrue: [ ^0 ].
	^amountWithheld at: aDate.! !

Withholder subclass: #RetirementWithholder
	instanceVariableNames: 'amountWithheld'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!RetirementWithholder commentStamp: '<historical>' prior: 0!
A RetirementWithholder is xxxxxxxxx.

Instance Variables
	amountWithheld:		<Object>

amountWithheld
	- xxxxx
!

!RetirementWithholder methodsFor: 'as yet unclassified' stamp: 'BrianDentino 6/23/2013 01:08'!
amountAt: aDate 
	^amountWithheld at: aDate! !

!RetirementWithholder methodsFor: 'as yet unclassified' stamp: 'BrianDentino 6/23/2013 01:08'!
initialize
	super initialize.
	amountWithheld := ValueWithHistory zero.! !

!RetirementWithholder methodsFor: 'as yet unclassified' stamp: 'BrianDentino 6/23/2013 01:08'!
setAmount: anAmount at: aDate
	amountWithheld starting: aDate become: anAmount! !

!RetirementWithholder methodsFor: 'as yet unclassified' stamp: 'LaurenBridge 6/23/2013 12:41'!
withholdingOn: aCheck for: anEmployee at: aDate
	(amountWithheld at: aDate) > (aCheck amountPaid) ifTrue: [ ^0 ].
	^amountWithheld at: aDate.! !

Withholder subclass: #TaxWithholder
	instanceVariableNames: 'taxRule'
	classVariableNames: 'HeadTaxRate MarriedSeparateTaxRate MarriedTaxRate SingleTaxRate'
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!TaxWithholder commentStamp: '<historical>' prior: 0!
A TaxWithholder is xxxxxxxxx.

Instance Variables
	taxRule:		<Object>

taxRule
	- xxxxx
!

!TaxWithholder class methodsFor: 'class initialization' stamp: 'BrianDentino 6/22/2013 18:13'!
initialize 
	SingleTaxRate := TaxRule new.
	SingleTaxRate
		breakPoint: 0 rate: 0.15;
		breakPoint: 22750 rate: 0.28;
		breakPoint: 55100 rate: 0.31;
		breakPoint: 115000 rate: 0.36;
		breakPoint: 250000 rate: 0.396.

	MarriedTaxRate := TaxRule new.
	MarriedTaxRate
		breakPoint: 0 rate: 0.15;
		breakPoint: 38000 rate: 0.28;
		breakPoint: 91850 rate: 0.31;
		breakPoint: 140000 rate: 0.36;
		breakPoint: 250000 rate: 0.396.

	MarriedSeparateTaxRate := TaxRule new.
	MarriedSeparateTaxRate
		breakPoint: 0 rate: 0.15;
		breakPoint: 19500 rate: 0.28;
		breakPoint: 45925 rate: 0.31;
		breakPoint: 70000 rate: 0.36;
		breakPoint: 125000 rate: 0.396.

	HeadTaxRate := TaxRule new.
	HeadTaxRate
		breakPoint: 0 rate: 0.15;
		breakPoint: 30500 rate: 0.28;
		breakPoint: 78700 rate: 0.31;
		breakPoint: 127500 rate: 0.36;
		breakPoint: 250000 rate: 0.396.
			! !

!TaxWithholder methodsFor: 'taxes' stamp: 'BrianDentino 6/22/2013 18:16'!
federalTaxesOn: money assumingTotalIs: estimatedEarnings
	^money * (taxRule rateFor: estimatedEarnings)! !

!TaxWithholder methodsFor: 'initialize-release' stamp: 'BrianDentino 6/23/2013 00:15'!
initialize 
	super initialize.
	taxRule := SingleTaxRate.! !

!TaxWithholder methodsFor: 'taxes' stamp: 'BrianDentino 6/23/2013 00:07'!
taxesOn: money for: anEmployee at: date 
	"Return the taxes to be withheld from the money earned."
	"This is just a guess - I didn't look up the tax rules."

	| socialSecurity federalTaxes stateTaxes estimatedEarnings |
	socialSecurity := (0 max: (money min: 60600 - (anEmployee earnedAt: date)))
				* 0.077.
	estimatedEarnings := (anEmployee earnedAt: date) + money * date day / date daysInYear.
	federalTaxes := self federalTaxesOn: money assumingTotalIs: estimatedEarnings.
	stateTaxes := money * 0.03.	"Illinois has a flat tax."
	^socialSecurity + federalTaxes + stateTaxes
			! !

!TaxWithholder methodsFor: 'withholding' stamp: 'BrianDentino 6/23/2013 00:07'!
withholdingOn: aCheck for: anEmployee at: aDate
	^self taxesOn: (aCheck amountPaid) for: anEmployee at: aDate.! !

!Withholder methodsFor: 'as yet unclassified' stamp: 'BrianDentino 6/23/2013 00:15'!
initialize
	totalWithholding := ValueWithHistory zero.! !

!Withholder methodsFor: 'as yet unclassified' stamp: 'BrianDentino 6/22/2013 19:20'!
totalWithholding
	^totalWithholding! !

!Withholder methodsFor: 'as yet unclassified' stamp: 'BrianDentino 6/22/2013 18:14'!
withholdingOn: aCheck for: anEmployee at: aDate 	
	self subclassResponsibility! !
Paycheck initialize!
ValueWithHistory initialize!
TaxWithholder initialize!
